#ifndef __HALL_OF_FAME_H__
#define __HALL_OF_FAME_H__

#include <string>
#include <vector> 

class HallOfFame {
private:
    struct Entry {
        std::string name;
        size_t points;
    };

public:
    explicit HallOfFame();

    void Draw();
    void Update(double dt);
    void ProcessEvents();

    bool IsDone() const { return m_is_done; }

private:
    void LoadFromFile();

private:
    bool m_is_done;
    std::vector<Entry> m_entries;
};

#endif /* __HALL_OF_FAME_H__ */
